/* $Id: DCUPComponentManagerRMIStub.java,v 1.5 2002/10/08 16:14:12 hnetynka Exp $ */
package SOFA.Connector.Boot;

import SOFA.Connector.*;
import SOFA.Component.*;
import SOFA.Component.DCUP.*;
import SOFA.SOFAnode.Run.*;
import java.rmi.*;

public class DCUPComponentManagerRMIStub implements CNDCUPComponentManagerInterface {

  private CNDCUPComponentManagerRemoteInterface tgt = null;

  public DCUPComponentManagerRMIStub(String name) throws RemoteException {
    try {
      tgt = (CNDCUPComponentManagerRemoteInterface) java.rmi.Naming.lookup(name);
    } catch (Exception e) {
      throw new RemoteException("Can't find skeleton", e);
    }
  }

  public void createComponent(Storage stateStore) throws ComponentLifecycleException {
    try {
      tgt.createComponent(stateStore);
    } catch (RemoteException e){
      throw new ConnectorTransportException("Remote exception in the \"createComponent\".", e);
    }
  }

  public void destroyComponent(Storage stateStore) throws ComponentLifecycleException {

    try {
      tgt.destroyComponent(stateStore);
    } catch (RemoteException e){
      throw new ConnectorTransportException("Remote exception in the \"destroyComponent\".", e);
    }
  }

  public void storeComponent(Storage stateStore) throws ComponentLifecycleException {
    try {
      tgt.storeComponent(stateStore);
    } catch (RemoteException e){
      throw new ConnectorTransportException("Remote exception in the \"storeComponent\".", e);
    }
  }

  public void restoreComponent(Storage stateStore) throws ComponentLifecycleException {
    try {
      tgt.restoreComponent(stateStore);
    } catch (RemoteException e){
      throw new ConnectorTransportException("Remote exception in the \"restoreComponent\".", e);
    }
  }


  public void registerSubcomponent(java.lang.String name, SOFA.Connector.Reference target) throws SOFA.Component.NamingException, SOFA.Component.InstantiationException {
    try {
      cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
      target._write(os);
      
      tgt.registerSubcomponent(name, os.toByteArray());

    } catch (RemoteException e){
      throw new ConnectorTransportException("Remote exception in the \"registerSubcomponent\".", e);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("IOException in the \"registerSubcomponent\".", e);
    }
  }
  
  public void unregisterSubcomponent(java.lang.String name) throws SOFA.Component.NamingException {
    try {
      tgt.unregisterSubcomponent(name);
    } catch (RemoteException e){
      throw new ConnectorTransportException("Remote exception in the \"unregisterSubcomponent\".", e);
    }
  }


  public void updateComponent( SOFA.SOFAnode.Run.Deployment.DeploymentDescriptor newDeploymentDescriptor, Storage stateStore) throws ComponentLifecycleException {
    try {
      cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
      newDeploymentDescriptor._write(os);

      tgt.updateComponent(os.toByteArray(), stateStore);
    } catch (RemoteException e){
      throw new ConnectorTransportException("Remote exception in the \"updateComponent\".", e);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("IOException in the \"updateComponent\".", e);
    }
  }

  public SOFA.Connector.Reference getProvisionReference(String name) throws NamingException {
    try {
      byte [] s = tgt.getProvisionReference(name);
      
      SOFA.Connector.Reference ref = new SOFA.Connector.Reference ();
      ref._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(s));
      return ref;
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the \"getProvisionReference\".", e);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("IOException in the \"getProvisionReference\".", e);
    }
  }
  
  public void setRequirement(String name, SOFA.Connector.Reference ref) throws SOFA.Component.InstantiationException, NamingException {
    try {
      cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
      ref._write(os);

      tgt.setRequirement(name, os.toByteArray());
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the \"setRequirement\".", e);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("IOException in the \"setRequirement\".", e);
    }
  }
  
  public void connectSubsumable() throws NamingException, SOFA.Component.InstantiationException {
    try {
      tgt.connectSubsumable();
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the \"setRequirement\".", e);
    }
  }

  public SOFA.SOFAnode.Run.Deployment.DeplDock getLocalDeplDock() {
    return null;
  }

  public String getFullName() {
    try {
      return tgt.getFullName();
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the \"setRequirement\".", e);
    }
  }

  public boolean isUpdatable() {
    try {
      return tgt.isUpdatable();
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the \"setRequirement\".", e);
    }
  }


}
