/* $Id: DeplDockRMIStub.java,v 1.7 2002/07/31 10:15:38 hnetynka Exp $ */
package SOFA.Connector.Boot;

import SOFA.Connector.ConnectorTransportException;

/** RMI stub for DeplDock connector.
  *
  * @author Petr Hnetynka
  */
public class DeplDockRMIStub implements CNDeplDock {
  private CNDeplDockRemote tgt = null;

  public DeplDockRMIStub(String url) throws java.rmi.RemoteException {
    try {
      tgt = (CNDeplDockRemote) java.rmi.Naming.lookup(url);
    } catch (java.net.MalformedURLException e) {
      throw new java.rmi.RemoteException("Can't create DeplDockRMIStub", e);
    } catch (java.rmi.NotBoundException e) {
      throw new java.rmi.RemoteException("Can't create DeplDockRMIStub", e);
    }
  }

  public SOFA.SOFAnode.Run.Deployment.TechnologyDescriptor[] describeUnderlyingEnvironment() {
    try {
      byte[][] s = tgt.describeUnderlyingEnvironment();
      SOFA.SOFAnode.Run.Deployment.TechnologyDescriptor[] td = new SOFA.SOFAnode.Run.Deployment.TechnologyDescriptor[s.length];
      for (int i=0; i<s.length; i++) {
        td[i] = new SOFA.SOFAnode.Run.Deployment.TechnologyDescriptor();
        td[i]._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(s[i]));
      }
      return td;
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the \"describeUnderlyingEnvironment\".", e);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("IOException in the \"describeUnderlyingEnvironment\".", e);
    }
  }
  
  public SOFA.Connector.Reference instantiate(SOFA.SOFAnode.Run.Deployment.DeploymentDescriptor dd, String name) throws SOFA.SOFAnode.Run.Deployment.DeploymentException {
    try {
      cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
      dd._write(os);
      
      byte[] s = tgt.instantiate(os.toByteArray(), name);

      SOFA.Connector.Reference ref = new SOFA.Connector.Reference ();
      ref._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(s));
      return ref;
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the \"instantiate\".", e);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("IOException in the \"instantiate\".", e);
    }
  }

  public SOFA.Connector.Reference getReference(String name) throws SOFA.SOFAnode.Run.Deployment.DeploymentException {
    try {
      
      byte[] s = tgt.getReference(name);

      SOFA.Connector.Reference ref = new SOFA.Connector.Reference ();
      ref._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(s));
      return ref;
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the \"getReference\".", e);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("IOException in the \"getReference\".", e);
    }
  }

  public String[] namesOfAllRunningComponents() {
    try {
      return tgt.namesOfAllRunningComponents();
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the \"namesOfAllRunningComponents\".", e);
    }
  }
  
  public String[] namesOfAllRunningApplications() {
    try {
      return tgt.namesOfAllRunningApplications();
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the \"namesOfAllRunningApplications\".", e);
    }
  }

  public void removeComponent(String name) throws SOFA.SOFAnode.Run.Deployment.DeploymentException {
    try {
      tgt.removeComponent(name);
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the \"removeComponent\".", e);
    }
  }


}
