/*
 * CDL2IDL2JavaMapping.java
 *
 * Created on 7. duben 2002, 10:23
 */

package SOFA.Connector.EEG.CodeWriter;

import SOFA.SOFAnode.Made.TIR.*;
import SOFA.SOFAnode.Made.TIR.Access.TIRAccessMethods;

/**
 *
 * @author  ghort
 * @version 
 */
public class CDL2IDL2JavaMapping {

	static protected SOFA.SOFAnode.Made.CodeGen.JavaMapping mapping;

	static public String getTypeName(CDLType cdlType, int paramMode) throws CodeWriterException {
		if (mapping==null) {
			mapping=new SOFA.SOFAnode.Made.CodeGen.JavaMapping();
		}
		String ret;

		if (paramMode==ParamMode.PARAM_IN) {
			ret=mapping.getImplTypeName(cdlType);
		} else {
			ret=mapping.getImplTypeHolderName(cdlType);
			// FIXME, zatim to funguje jen pro prim. typy, takze muzeme predpokladat, ze vsechny holdery jsou
			// v package cz.cuni.sofa.lib
			ret="org.omg.CORBA"+ret.substring("cz.cuni.sofa.lib".length());
		}

		if (ret==null) {
			throw new CodeWriterException("Cannot map CDL->IDL type to Java.");
		}
		return ret;
	}

	static public String getAbsoluteName(AbsoluteName an) throws CodeWriterException {
		try {
			int i, size=an.size();
			String ret=an.elementAt(0);
			for (i=1;i<size;i++) {
				ret+="."+an.elementAt(i);
			}
			return ret;
		} catch (java.rmi.RemoteException e) {
			throw new CodeWriterException("Can't access TIR.",e);
		}
	}
}
