/*
 * IDL.java
 *
 * Created on 2. duben 2002, 23:37
 */

package SOFA.Connector.EEG.EEM.Actions;

import SOFA.Connector.EEG.EEM.*;

/**
 *
 * @author  ghort
 * @version 
 */
public class IDL implements ActionInterface {
	protected String include;

	/** Creates new IDL */
   public IDL(java.util.HashMap props) {
		include=(String)props.get("include");
   }

	public String getName() {
		return "idl";
	}
	 
	public void perform(SOFA.Connector.Property[] params, String sourceDir, String sourcePackage, String destDir, String destPackage) throws ActionException {
		String source;
		if ((source=SOFA.Connector.Property.findFirst(params,"source"))==null) {
			throw new ActionException("source param not specified");
		}
		 
		int ret;
		try {
			Runtime runtime=Runtime.getRuntime();
			Process process=runtime.exec("idlj -td "+SOFA.Util.ConnGenPathInfo.getRMICOutDir()+"  -fall "+(include!=null?"-i "+include+" ":"")+destDir+"/"+source);
			ret=process.waitFor();
		} catch (Exception e) {
			throw new ActionException("Can't create classes from idl file "+destPackage+"/"+source+".",e);
		}
		if (ret!=0) {
			throw new ActionException("Creating classes from IDL 'idlj -fall "+(include!=null?"-i "+include+" ":"")+destDir+"/"+source+"' returned error ("+ret+").");
		}
	}
	 
}
