/*
 * RMISkeletonGen.java
 *
 * Created on 13. duben 2002, 21:08
 */

package SOFA.Connector.EEG.EEM.Elements;

import SOFA.SOFAnode.Made.TIR.*;
import SOFA.SOFAnode.Made.TIR.Access.TIRAccessMethods;
import SOFA.Connector.EEG.CodeWriter.*;
import SOFA.Connector.EEG.EEM.Actions.*;

/**
 *
 * @author  ghort
 * @version 
 */
public class RMISkeletonGen extends JImplWriterDirectorBase {

	/** Creates new RMISkeletonGen */
	public RMISkeletonGen(String provIfaceCDL, SOFA.Connector.Property[] params) {
		super(provIfaceCDL,params);
	}

	public String getExtends() {
		return "java.rmi.server.UnicastRemoteObject";
	}

	public String[] getImplements() {
		return new String[] {"SOFA.Connector.EEG.Types.Skeleton"};
	}
	
	public String getClassBody() {
		return managerTieImpl() + "\n" + linkImpl() + "\n" +
			"\tprotected String rmiURL;\n\n"+
			"\tpublic RMISkeleton() throws SOFA.Connector.ConnectorException, java.rmi.RemoteException {\n"+
			"\t\tsuper();\n"+
			"\t\ttry {\n"+
			"\t\t\tString rmihost = System.getProperty(\"sofa.rmihost\", \"localhost\");\n"+
			"\t\t\tString rmiport = System.getProperty(\"sofa.rmiport\", \"1099\");\n"+
			"\t\t\trmiURL=\"rmi://\"+rmihost+\":\"+rmiport+\"/SOFA/Connectors/EEG/EEM/Elements/RMISkeleton/\"+new java.rmi.server.UID();\n"+
			"\t\t\tjava.rmi.Naming.rebind(rmiURL,this);\n"+
			"\t\t} catch (Exception e) {\n"+
			"\t\t\tthrow new SOFA.Connector.ConnectorException(\"Can't bind RMISkeleton to '\"+rmiURL+\"'.\",e);\n"+
			"\t\t}\n"+
			"\t}\n\n"+
			"\tpublic SOFA.Connector.TaggedProfile[] getProfiles() {\n"+
			"\t\treturn new SOFA.Connector.TaggedProfile[] { new SOFA.Connector.ECG.Profiles.RMIProfile(rmiURL) };\n"+
			"\t}\n";
	}

	public String getMethodDef(OperationDef mt) throws JWriterDirectorException {
		return JIfaceCNRMI.getMethodDef(mt);
	}

	public String getMethodBody(OperationDef method) throws JWriterDirectorException {
		return 
			"\t\t"+declareRet(method,"ret")+"\n"+
			"\t\t"+assignRet(method,"ret")+targetCall(method,JIfaceCN.targetCallParams(method))+";\n"+
			"\t\t"+returnRet(method,"ret");
	}
}
