/* $Id: Reference.java,v 1.4 2002/10/08 16:14:11 hnetynka Exp $ */
package SOFA.Connector;

import SOFA.Connector.ECG.Profiles.*;

/** Connector reference.
  */
public final class Reference implements java.io.Serializable, cz.cuni.sofa.lib.Streamable {
  
  /** Type of the connector - CSProcCall, EventPassing, DataStream */
  public String conn_type;
  /** Profiles */
  public TaggedProfile[] profiles;

  public Reference () {
  }

  public Reference (final String conn_type, final TaggedProfile[] profiles) {
    this.conn_type = conn_type;
    this.profiles = profiles;
  }

  public void _write(cz.cuni.sofa.lib.OutputStream os) throws java.io.IOException {
    os.write_string(conn_type);
    int len = 0;
    for (int i=0; i<profiles.length; i++) {
      if (profiles[i] instanceof RMIProfile || profiles[i] instanceof CORBAProfile) {
        len++;
      }
    }
    os.write_long(len);
    for (int i=0; i<profiles.length; i++) {
      if (profiles[i] instanceof RMIProfile) {
        os.write_string(profiles[i].tag);
        os.write_string( ((RMIProfile) profiles[i]).URL);
      }
      if (profiles[i] instanceof CORBAProfile) {
        os.write_string(profiles[i].tag);
        os.write_string( ((CORBAProfile) profiles[i]).IOR);
      }
    }
  }
  
  public void _read(cz.cuni.sofa.lib.InputStream is) throws java.io.IOException {
    conn_type = is.read_string();
    int len = is.read_long();
    profiles = new TaggedProfile [len];
    for (int i=0; i<len; i++) {
      String tag = is.read_string();
      if (tag.compareTo("RMI")==0) {
        profiles[i] = new RMIProfile(is.read_string());
      }
      if (tag.compareTo("CORBA")==0) {
        profiles[i] = new CORBAProfile(is.read_string());
      }
    }
  }

  public String toString() {
    StringBuffer sb = new StringBuffer(conn_type);
    sb.append("-");
    for (int i=0; i<profiles.length; i++) {
      if (profiles[i] instanceof RMIProfile) {
        sb.append(profiles[i].tag);
        sb.append(";");
        sb.append( ((RMIProfile) profiles[i]).URL);
        sb.append("-");
      }
      if (profiles[i] instanceof CORBAProfile) {
        sb.append(profiles[i].tag);
        sb.append("x"); 
        sb.append( ((CORBAProfile) profiles[i]).IOR);
        sb.append("-");
      }
      if (profiles[i] instanceof LocalProfile) {
        sb.append(profiles[i].tag);
        sb.append("-");
      }

    }
    return sb.toString();
  }
}
