/* $Id: CompModule.java,v 2.1 2002/04/17 13:41:40 hnetynka Exp $ */
package SOFA.SOFAnode.Made.CDL;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;

class CompModule extends CompContainedContainerIm {

  public CompModule(ID id, CompContainer in, CompRepository inRep) {
    super(ObjectsKind.o_Module, id, in, inRep);
  }

  public void addToNormal(Container obj, CDLRepository normRep, java.util.ArrayList delayed) throws CDLExceptToNormal, CDLExceptRemote, CDLExceptLock {
    cont.toFirst();
    try {
      for (int i=0;i<cont.size(); i++) {
        CompContained akt = (CompContained) cont.aktual();
        switch (akt.objectKind()) {
        // *****************
        case ObjectsKind.o_Module:
          Contained[] cmod = obj.lookup_name(akt.getIdent().name);
          if ((cmod == null) || (cmod.length == 0)) { //create ne module
            ModuleDef mod = null;
            try {
              mod = ((CDLContainer) obj).create_module(akt.getIdent().id);
            } catch (TIRExceptCreate ecr) {
              throw new CDLExceptToNormal("Can't create module "+((CompContained)akt).fullName());
            }
            if (mod==null)
              throw new CDLExceptToNormal("Can't create module "+((CompContained)akt).fullName());
            ((CompContainer) akt).addToNormal(mod, normRep, delayed);
          } else { // use old module
            if (cmod.length!=1)
              throw new CDLExceptToNormal("Unexpected error");
            ((CompContainer) akt).addToNormal((Container) cmod[0], normRep, delayed);
          }
          break;
        // *****************
        case ObjectsKind.o_Typedef:
          try {
            TypedefDef td =( (CDLContainer) obj).create_typedef(akt.getIdent().id, ((CompTypedef) akt).type.toNormal(normRep));
            if (td == null) 
              throw new CDLExceptToNormal("Can't create typedef "+((CompContained)akt).fullName());
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create typedef "+((CompContained)akt).fullName()+"\n"+
                                          ecr.getMessage());
          }
          break;
        // *****************
        case ObjectsKind.o_Enum:
          try {
            EnumDef en = ((CDLContainer) obj).create_enum(akt.getIdent().id);
            if (en == null) 
              throw new CDLExceptToNormal("Can't create typedef "+((CompContained)akt).fullName());
            ((CompEnum) akt).addToNormal(en);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create enum "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Struct:
          try {
            StructDef str = ((CDLContainer) obj).create_struct(akt.getIdent().id);
            if (str == null) 
              throw new CDLExceptToNormal("Can't create struct "+((CompContained)akt).fullName());
            ((CompStruct) akt).addToNormal(str, normRep, delayed);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create struct "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Union:
          try {
            UnionDef un = ((CDLContainer) obj).create_union(akt.getIdent().id, ((CompUnion) akt).switch_type.toNormal(normRep));
            if (un == null) 
              throw new CDLExceptToNormal("Can't create union "+((CompContained)akt).fullName());
            ((CompUnion) akt).addToNormal(un, normRep, delayed);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create union "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Exception:
          try {
            ExceptionDef str = ((CDLContainer) obj).create_exception(akt.getIdent().id);
            if (str == null) 
              throw new CDLExceptToNormal("Can't create exception "+((CompContained)akt).fullName());
            ((CompException) akt).addToNormal(str, normRep, delayed);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create exception "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Constant:
          try {
            ConstantDef cnst;
            if (((CompConstant) akt).type.objectKind() == ObjectsKind.o_Fixed) {
              ExprOperDef expr = ((CompExprOper) ((CompConstant)akt).expr).toNormal(normRep);
              ExprOperDef cexpr = null;
              try {
                cexpr = expr.calculate();
              } catch (TIRExceptCalculate e) {
                throw new CDLExceptToNormal("Bad expression in the constant "+((CompContained)akt).fullName());
              }
              ((CompFixed) ((CompConstant) akt).type).digits = new CompExprInteger(((ExprFixed) cexpr).digits());
              ((CompFixed) ((CompConstant) akt).type).scale = new CompExprInteger(((ExprFixed) cexpr).scale());
              cnst = ((CDLContainer) obj).create_constant(akt.getIdent().id, ((CompConstant) akt).type.toNormal(normRep), expr);
            } else {
              cnst = ((CDLContainer) obj).create_constant(akt.getIdent().id, ((CompConstant) akt).type.toNormal(normRep), ((CompExprOper) ((CompConstant)akt).expr).toNormal(normRep));
            }
            if (cnst == null) 
              throw new CDLExceptToNormal("Can't create constant "+((CompContained)akt).fullName());
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create constant "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Interface:
          try {
           /* InterfaceDef[] base = null;
            if (((CompInterface) akt).baseIfaces != null) {
              ((CompInterface) akt).baseIfaces.toFirst();
              base = new InterfaceDef [((CompInterface) akt).baseIfaces.size()];
              for (int j=0;j<((CompInterface) akt).baseIfaces.size();j++) {
                base[j] = (InterfaceDef) ((CompType) ((CompInterface) akt).baseIfaces.aktual()).toNormal(normRep);
                ((CompInterface) akt).baseIfaces.toNext();
              }
            } else {
              base =  new InterfaceDef [0];
            } */
            InterfaceDef iface = ((CDLContainer) obj).create_interface(akt.getIdent().id /*,base*/);
            if (iface == null) 
              throw new CDLExceptToNormal("Can't create interface "+((CompContained)akt).fullName());
            ((CompInterface) akt).addToNormal(iface, normRep, delayed);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create interface "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Frame:
          try {
            FrameDef frm = ((CDLContainer) obj).create_frame(akt.getIdent().id, ((CompFrame)akt).isSystem);
            if (frm == null) 
              throw new CDLExceptToNormal("Can't create frame "+((CompContained)akt).fullName());
            ((CompFrame) akt).addToNormal(frm, normRep, delayed);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create frame "+((CompContained)akt).fullName());
          }
          break;
        default:
          throw new CDLExceptToNormal("Unexcepted kind of object");
        }
        cont.toNext();
      }
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptLock e) {
      throw new CDLExceptLock("Repository is locked.");
    }
  }

  public void checkConsist(EnumList props, CompRepository rep) throws CDLExceptCheck, CDLExceptLock, CDLExceptRemote {
    CompContained[] cont = contents();
    for (int i=0;i<cont.length;i++) {
      switch (cont[i].objectKind()) {
      case ObjectsKind.o_Module:
        cont[i].checkConsist(null,rep);
        break;
      case ObjectsKind.o_Interface:
        cont[i].checkConsist(null,rep);
        break;
      case ObjectsKind.o_Frame:
        try {
          cont[i].checkConsist(null,rep);
        } catch (CDLExceptCheck e) {
          throw new CDLExceptCheck(e.getMessage()+" in frame "+cont[i].fullName());
        }
        break;
      }
    }
  }
}
