/* $Id: CompProvide.java,v 2.2 2002/04/19 13:04:03 hnetynka Exp $ */
package SOFA.SOFAnode.Made.CDL;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;
 
class CompProvide extends CompContainedIm {
  CompReffer type;
  EnumList operations;
  String typeCode;
  
  public CompProvide(ID id, CompContainer in, CompRepository inRep, CompReffer t, EnumList op, String tC) {
    super(ObjectsKind.o_Provides, id, in, inRep);
    id.version = ((CompContained) in).getIdent().version;
    type = t;
    operations = op;
    typeCode = tC;
//    Debug.message("Vytvarim provide: "+id);
  }

  public boolean containsArray() {
    if (typeCode.indexOf('a')!=-1)
      return true;
    return false;
  }

  public static CompReffer canBeProvReq(FullID idp, EnumList propNames, CompRepository inRep, EnumList operNm, StringBuffer typeCode) throws CDLExceptLock, CDLExceptRemote {
    EnumList operNames = null;
    CompReffer what = null;
//  long tmb = java.util.Calendar.getInstance().getTime().getTime();
    if ((what = inRep.searchReffer(idp, 1))==null) {   // number 1 --- skip name space of this provide, search in upper
      return null;
    } 
    if (System.getProperty("cdl.disableBindTests","no").compareTo("yes")==0) {
      return what;
    }
//  long tme = java.util.Calendar.getInstance().getTime().getTime();
//  Output.out.println("*****"+Long.toString(tme-tmb)+" ms "+idp.toString());
    // test if "what" is iface or array of ifaces
    boolean ok = false;
    int kind = what.what;
    CompReffer r = what;
    while (!ok) {
//          Debug.message("*canBePR 1*  "+r+"***"+kind);
      if (kind != ObjectsKind.o_Interface) {
        if (kind == ObjectsKind.o_Typedef || kind == ObjectsKind.o_Array) {
          int i,j;
          FullID id = r.ref;
          if (r.isNew) {  // in actually added objects
            CompContainer con = inRep;
            id.sn.names.toFirst();
            for(i=0;i<id.sn.names.size();i++) {
              CompContained[] a = con.lookup((String) id.sn.names.aktual());
              if (a==null || a.length==0) {
                inRep.searchError = "this can't be provision";
                return null;
              }  
              if (a.length==1) {
                if (a[0].isContainer()) con = (CompContainer) a[0];
                else {
                  inRep.searchError = "this can't be provision";
                  return null;
                }  
              } else {
                inRep.searchError = "this can't be provision";
                return null;
              }
              id.sn.names.toNext();
            }
            CompContained sec = con.lookup(id.name, id.version);
            if (sec!=null) {
              CompType sectype = ((CompTypedef) sec).type;
              if (sectype.objectKind() != ObjectsKind.o_Interface) {
                if (sectype.objectKind()==ObjectsKind.o_none) { // is CompReffer
                  r = (CompReffer) sectype;
                  kind = r.what;
                } else {
                  if (sectype.objectKind()==ObjectsKind.o_Array) {
                    while (sectype.objectKind()==ObjectsKind.o_Array) {
                       typeCode.append('a');
                       // test property in array length
                       EnumList exprProp = ((CompArray) sectype).length.nameProp(inRep);
                       if (!CompExprOper.testPropInExpr(propNames,exprProp)) {
                         inRep.searchError = "unknown property";
                         return null;
                       }
                       sectype = ((CompArray) sectype).type;
                    }
                    if (sectype.objectKind() != ObjectsKind.o_none) {
                      if (sectype.objectKind() == ObjectsKind.o_Interface) {
                        typeCode.append('i');
                        operNames = ((CompInterface) sectype).operationNames();
                        ok = true;
                      } else {
                        inRep.searchError = "this can't be provision";
                        return null;
                      }  
                    } else {
                      r = (CompReffer) sectype;
                      kind = r.what;
                    }
                  } else {
                    inRep.searchError = "this can't be provision";
                    return null;
                  }
                }  
              } else {
                typeCode.append('i');
                operNames = ((CompInterface) sectype).operationNames();
                ok = true;
              }
            } else {
              inRep.searchError = "this can't be provision";
              return null;
            }  
          } else {  // in normal repository
            try {
              Container con = inRep.cdlRepository;
              id.sn.names.toFirst();
              for(i=0;i<id.sn.names.size();i++) {
                Contained[] a = con.lookup_name((String) id.sn.names.aktual());
                if (a==null || a.length==0) {
                  inRep.searchError = "this can't be provision";
                  return null;
                }  
                if (a.length==1) {
                  if (a[0] instanceof Container) con = (Container) a[0];
                  else {
                    inRep.searchError = "this can't be provision";
                    return null;
                  }  
                } else {
                  boolean found = false;
                  for(j=0;j<a.length;j++) {
                    if (a[j].get_identification().version().compareTo(id.version)==0) {
                      if ( !(a[j] instanceof Container)) {
                        inRep.searchError = "this can't be provision";
                        return null;
                      }  
                      found = true;
                      con = (Container) a[j];
                      break;
                    }
                  }
                  if (!found) {
                    inRep.searchError = "this can't be provision";
                    return null;
                  }
                }
                id.sn.names.toNext();
              }
              Contained sec = con.lookup(id.name, id.version);
              if (sec!=null) {
                CDLType sectype = ((TypedefDef) sec).original_type();
                if (sectype.get_def_kind().value() != DefinitionKind.dk_Interface) {
                  if (sectype.get_def_kind().value() == DefinitionKind.dk_Typedef) {
                    CompReffer ret = new CompReffer();
                    ret.what = sectype.get_def_kind().value();
                    ret.ref = new FullID(true);
                    Identification idl;
                    ret.ref.name = new String((idl = ((TypedefDef)sectype).get_identification()).name());
                    ret.ref.version = new String(idl.version());
                    ret.ref.isin = IDKind.version;
                    ret.isNew = false;
                    AbsoluteName abs = idl.absolute_name();
                    for(j=0;j<abs.size();j++) {
                      ret.ref.sn.addScope(new String(abs.elementAt(j)));
                    }
                    r = ret;
                    kind = r.what;
                  } else {
                    if (sectype.get_def_kind().value()==DefinitionKind.dk_Array) {
                      while (sectype.get_def_kind().value()==DefinitionKind.dk_Array) {
                        typeCode.append('a');
                        // test property in array length
                        EnumList exprProp = CompExprOper.scanNormalExpr(((ArrayDef) sectype).length());
                        if (!CompExprOper.testPropInExpr(propNames,exprProp)) {
                          inRep.searchError = "unknown property";
                          return null;
                        }
                        sectype = ((ArrayDef) sectype).element_type();
                      }
                      if (sectype.get_def_kind().value()!=DefinitionKind.dk_Typedef) {
                        if (sectype.get_def_kind().value()==DefinitionKind.dk_Interface) {
                          typeCode.append('i');
                          operNames = normIfaceOperations((InterfaceDef) sectype, inRep);
                          ok = true;
                        } else { 
                          inRep.searchError = "this can't be provision";
                          return null;
                        }
                      } else {
                        CompReffer ret = new CompReffer();
                        ret.what = sectype.get_def_kind().value();
                        ret.ref = new FullID(true);
                        Identification idl;
                        ret.ref.name = new String((idl = ((TypedefDef)sectype).get_identification()).name());
                        ret.ref.version = new String(idl.version());
                        ret.ref.isin = IDKind.version;
                        ret.isNew = false;
                        AbsoluteName abs = idl.absolute_name();
                        for(j=0;j<abs.size();j++) {
                          ret.ref.sn.addScope(new String(abs.elementAt(j)));
                        }
                        r = ret;
                        kind = r.what;   
                      }
                    } else {
                      inRep.searchError = "this can't be provision";
                      return null;
                    }
                  }  
                } else {
                  typeCode.append('i');
                  operNames = normIfaceOperations((InterfaceDef) sectype, inRep);
                  ok = true;
                }
              } else {
                inRep.searchError = "this can't be provision";
                return null;
              }
            } catch (TIRExceptLock e) {
              throw new CDLExceptLock("Repository is locked.");
            } catch (RemoteException e) {
              throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
            }
          }
        } else {
	  inRep.searchError = "this can't be provision";
          return null;
	}
      } else {
        typeCode.append('i');
        operNames = ifaceOperations(r, inRep);
        ok = true;
      }
    }
    // copy list of operation names
    operNames.toFirst();
    for(int i=0;i<operNames.size();i++) {
      operNm.addName((String) operNames.aktual());
      operNames.toNext();
    }
    return what;
  }

  public static EnumList ifaceOperations(CompReffer ref, CompRepository inRep) throws CDLExceptLock, CDLExceptRemote {
    int i;
    if (ref.isNew) {
      CompContainer con = inRep;
      ref.ref.sn.names.toFirst();
      for(i=0;i<ref.ref.sn.names.size();i++) {
        CompContained[] a = con.lookup((String) ref.ref.sn.names.aktual());
        if (a==null || a.length==0) {
          return null;
        }  
        if (a.length==1) {
          if (a[0].isContainer()) con = (CompContainer) a[0];
          else {
            return null;
          }  
        } else {
          return null;
        }
        ref.ref.sn.names.toNext();
      }
      CompContained sec = con.lookup(ref.ref.name, ref.ref.version);
      if (sec==null)
        return null;
      return ((CompInterface) sec).operationNames();
    } else {
      try {
        Container con = inRep.cdlRepository;
        ref.ref.sn.names.toFirst();
        for(i=0;i<ref.ref.sn.names.size();i++) {
          Contained[] a = con.lookup_name((String) ref.ref.sn.names.aktual());
          if (a==null || a.length==0) {
            return null;
          }  
          if (a.length==1) {
            if (a[0] instanceof Container) con = (Container) a[0];
            else {
              return null;
            }  
          } else {
            boolean found = false;
            for(int j=0;j<a.length;j++) {
              if (a[j].get_identification().version().compareTo(ref.ref.version)==0) {
                if ( !(a[j] instanceof Container)) {
                  return null;
                }  
                found = true;
                con = (Container) a[j];
                break;
              }
            }
            if (!found) {
              return null;
            }
          }
          ref.ref.sn.names.toNext();
        }
        Contained sec = con.lookup(ref.ref.name, ref.ref.version);
        if (sec==null) 
          return null;
        return normIfaceOperations((InterfaceDef) sec, inRep);
      } catch (TIRExceptLock e) {
        throw new CDLExceptLock("Repository is locked.");
      } catch (RemoteException e) {
        throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
      }
    }
  }

  private static EnumList normIfaceOperations(InterfaceDef sec, CompRepository inRep) throws TIRExceptLock, RemoteException {
    EnumList ret = new EnumList();
    DefinitionKind dkoper = inRep.workRepository.get_spec_def_kind(DefinitionKind.dk_Operation);
    Contained[] obj =  sec.contents(dkoper);
    for (int j=0;j<obj.length;j++) {  // testing 
      ret.addName(obj[j].get_identification().name());
    }
    baseIfacesOperations((InterfaceDef) sec, ret, dkoper);
    return ret;
  }

  private static void baseIfacesOperations(InterfaceDef iface, EnumList names, DefinitionKind dkoper) throws TIRExceptLock, RemoteException {
    InterfaceDef[] bbase = ((InterfaceDef) iface).base_interfaces();
    for (int i=0;i<bbase.length;i++) {
      Contained[] obj = ((InterfaceDef) bbase[i]).contents(dkoper);
      for (int j=0;j<obj.length;j++) {
        names.addName(obj[j].get_identification().name());
      }
      baseIfacesOperations(bbase[i], names, dkoper);
    }
  }

  public boolean isOperation(String name) {
    return operations.isIn(name);
  }

  public void checkConsist(EnumList props, CompRepository rep) throws CDLExceptCheck, CDLExceptLock, CDLExceptRemote {
    type.checkConsist(props, rep);
  }

  /** Returns interface protocol adjusted to frame (add ?/! and instantion of iface).
      <b>Return values:</b><br>
      <ol><li>string with protocol</li><li><i>null</i>, if reffers array, or no protocol exists</li></ol>  */
  public String ifaceProtocol()  throws CDLExceptLock, CDLExceptRemote {
    if (typeCode.indexOf('a')==-1) 
      return CompProvide.realIfaceProtocol(type, "?", id.name, rep);
    else {
      CompReffer r = CompProvide.getProvReqIface(type.ref, rep);
      if (r!=null)
        return CompProvide.realIfaceProtocol(r, "?", id.name, rep);
      else
        return null;
    }
  }

  public static String realIfaceProtocol(CompReffer iface, String mode, String name, CompRepository inRep) throws CDLExceptLock, CDLExceptRemote {
    int i,j;
    if (iface.isNew) {
      CompContainer con = inRep;
      iface.ref.sn.names.toFirst();
      for(i=0;i<iface.ref.sn.names.size();i++) {
        CompContained[] a = con.lookup((String) iface.ref.sn.names.aktual());
        if (a==null || a.length==0) {
          System.err.println("Error in searching interface "+iface.ref);
          return null;
        }  
        if (a.length==1) {
          if (a[0].isContainer()) con = (CompContainer) a[0];
          else {
            System.err.println("Error in searching interface "+iface.ref);
            return null;
          }  
        } else {
          System.err.println("Error in searching interface "+iface.ref);
          return null;
        }
        iface.ref.sn.names.toNext();
      }
      CompContained sec = con.lookup(iface.ref.name, iface.ref.version);
      if (sec!=null) {
        if (sec.objectKind()==ObjectsKind.o_Interface) {
          if (((CompInterface) sec).protocol != null)
            return compProtToText(((CompInterface) sec).protocol, mode, name);
          else {
            if (((CompInterface)sec).contents().length==0)
              return "";
            return null;
          }
        } else
          return null;
      } else {
        return null;
      }
    } else {  // searching iface in the normal repository
      try {
        FullID id = iface.ref;
        Container con = inRep.cdlRepository;
        id.sn.names.toFirst();
        for(i=0;i<id.sn.names.size();i++) {
          Contained[] a = con.lookup_name((String) id.sn.names.aktual());
          if (a==null || a.length==0) {
            System.err.println("Error in searching interface "+iface.ref);
            return null;
          }  
          if (a.length==1) {
            if (a[0] instanceof Container) con = (Container) a[0];
            else {
              System.err.println("Error in searching interface "+iface.ref);
              return null;
            }  
          } else {
            boolean found = false;
            for(j=0;j<a.length;j++) {
              if (a[j].get_identification().version().compareTo(id.version)==0) {
                if ( !(a[j] instanceof Container)) {
                  System.err.println("Error in searching interface "+iface.ref);
                  return null;
                }  
                found = true;
                con = (Container) a[j];
                break;
              }
            }
            if (!found) {
              System.err.println("Error in searching interface "+iface.ref);
              return null;
            }
          }
          id.sn.names.toNext();
        }
        Contained sec = con.lookup(id.name, id.version);
        if (sec!=null) {
          if (sec.get_def_kind().value()==DefinitionKind.dk_Interface) {
            if (((InterfaceDef) sec).protocol() != null)
              return normProtToText(((InterfaceDef) sec).protocol().protocol(), mode, name);
            else
              return null;
          } else
            return null;
        } else {
          return null;
        }
      } catch (TIRExceptLock e) {
        throw new CDLExceptLock("Repository is locked.");
      } catch (RemoteException e) {
        throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
      }
      
    }
  }

  public static String compProtToText(CompProtOper p, String mode, String name) {
    StringBuffer sb = new StringBuffer();
    switch (p.type) {
    case CompProtKind.p_operand:
      sb.append(mode);
      sb.append(name);
      sb.append(".");
      sb.append(((CompProtOperand) p).operand);
      break;
    case CompProtKind.p_nulloperand:
      sb.append("NULL");
      break;
    case CompProtKind.p_metaoperand:
      sb.append("[");
      sb.append(((CompProtMetaOperand) p).name);
      sb.append("]");
      break;
    case CompProtKind.p_repetition:
      sb.append("(");
      sb.append(compProtToText(((CompProtUnOper) p).operand, mode, name));
      sb.append(")*");
      break;
    case CompProtKind.p_andparallel:
      sb.append("(");
      sb.append(compProtToText(((CompProtBinOper) p).operand1, mode, name));
      sb.append(")|(");
      sb.append(compProtToText(((CompProtBinOper) p).operand2, mode, name));
      sb.append(")");
      break;
    case CompProtKind.p_orparallel:
      sb.append("(");
      sb.append(compProtToText(((CompProtBinOper) p).operand1, mode, name));
      sb.append(")||(");
      sb.append(compProtToText(((CompProtBinOper) p).operand2, mode, name));
      sb.append(")");
      break;
    case CompProtKind.p_alternative:
      sb.append("(");
      sb.append(compProtToText(((CompProtBinOper) p).operand1, mode, name));
      sb.append(")+(");
      sb.append(compProtToText(((CompProtBinOper) p).operand2, mode, name));
      sb.append(")");
      break;
    case CompProtKind.p_sequence:
      sb.append("(");
      sb.append(compProtToText(((CompProtBinOper) p).operand1, mode, name));
      sb.append(");(");
      sb.append(compProtToText(((CompProtBinOper) p).operand2, mode, name));
      sb.append(")");
      break;
    case CompProtKind.p_restriction:
      sb.append("(");
      sb.append(compProtToText(((CompProtBinOper) p).operand1, mode, name));
      sb.append(")/(");
      sb.append(compProtToText(((CompProtBinOper) p).operand2, mode, name));
      sb.append(")");
      break;
    default: break;
    }
    return sb.toString();
  }

  public static String normProtToText(ProtocolOperDef p, String mode, String name) throws RemoteException {
    StringBuffer sb = new StringBuffer();
    switch (p.get_po_kind().value()) {
    case ProtocolOperKind.pok_operand:
      sb.append(mode);
      sb.append(name);
      sb.append(".");
      sb.append(((ProtocolOperandDef) p).operand()[0]);
      break;
    case ProtocolOperKind.pok_nulloperand:
      sb.append("NULL");
      break;
    case ProtocolOperKind.pok_metaoperand:
      sb.append("[");
      sb.append(((ProtocolMetaOperandDef) p).name());
      sb.append("]");
      break;
    case ProtocolOperKind.pok_repetition:
      sb.append("(");
      sb.append(normProtToText(((ProtocolUnOperationDef) p).operand(), mode, name));
      sb.append(")*");
      break;
    case ProtocolOperKind.pok_andparallel:
      sb.append("(");
      sb.append(normProtToText(((ProtocolBinOperationDef) p).operand1(), mode, name));
      sb.append(")|(");
      sb.append(normProtToText(((ProtocolBinOperationDef) p).operand2(), mode, name));
      sb.append(")");
      break;
    case ProtocolOperKind.pok_orparallel:
      sb.append("(");
      sb.append(normProtToText(((ProtocolBinOperationDef) p).operand1(), mode, name));
      sb.append(")||(");
      sb.append(normProtToText(((ProtocolBinOperationDef) p).operand2(), mode, name));
      sb.append(")");
      break;
    case ProtocolOperKind.pok_alternative:
      sb.append("(");
      sb.append(normProtToText(((ProtocolBinOperationDef) p).operand1(), mode, name));
      sb.append(")+(");
      sb.append(normProtToText(((ProtocolBinOperationDef) p).operand2(), mode, name));
      sb.append(")");
      break;
    case ProtocolOperKind.pok_sequence:
      sb.append("(");
      sb.append(normProtToText(((ProtocolBinOperationDef) p).operand1(), mode, name));
      sb.append(");(");
      sb.append(normProtToText(((ProtocolBinOperationDef) p).operand2(), mode, name));
      sb.append(")");
      break;
    case ProtocolOperKind.pok_restriction:
      sb.append("(");
      sb.append(normProtToText(((ProtocolBinOperationDef) p).operand1(), mode, name));
      sb.append(")/(");
      sb.append(normProtToText(((ProtocolBinOperationDef) p).operand2(), mode, name));
      sb.append(")");
      break;
    default: break;
    }
    return sb.toString();
  }

  /** Returns interface which is provided/reqired even if it is array of interfaces */
  public static CompReffer getProvReqIface(FullID idp, CompRepository inRep) throws CDLExceptLock, CDLExceptRemote {
    CompReffer what = null;
    if ((what = inRep.searchReffer(idp))==null) {
      return null;
    }  
    // test if "what" is iface or array of ifaces
    boolean ok = false;
    int kind = what.what;
    CompReffer r = what;
    while (!ok) {
//          Debug.message("*canBePR 1*  "+r+"***"+kind);
      if (kind != ObjectsKind.o_Interface) {
        if (kind == ObjectsKind.o_Typedef || kind == ObjectsKind.o_Array) {
          int i,j;
          FullID id = r.ref;
          if (r.isNew) {  // in actually added objects
            CompContainer con = inRep;
            id.sn.names.toFirst();
            for(i=0;i<id.sn.names.size();i++) {
              CompContained[] a = con.lookup((String) id.sn.names.aktual());
              if (a==null || a.length==0) {
                return null;
              }  
              if (a.length==1) {
                if (a[0].isContainer()) con = (CompContainer) a[0];
                else {
                  return null;
                }  
              } else {
                return null;
              }
              id.sn.names.toNext();
            }
            CompContained sec = con.lookup(id.name, id.version);
            if (sec!=null) {
              CompType sectype = ((CompTypedef) sec).type;
              if (sectype.objectKind() != ObjectsKind.o_Interface) {
                if (sectype.objectKind()==ObjectsKind.o_none) { // is CompReffer
                  r = (CompReffer) sectype;
                  kind = r.what;
                } else {
                  if (sectype.objectKind()==ObjectsKind.o_Array) {
                    while (sectype.objectKind()==ObjectsKind.o_Array) {
                       sectype = ((CompArray) sectype).type;
                    }
                    if (sectype.objectKind() != ObjectsKind.o_none) {
                      if (sectype.objectKind() == ObjectsKind.o_Interface) {
                        //!!! vytvor   r  , asi to je takhle
                        r = (CompReffer) sectype;
                        ok = true;
                      } else {
                        return null;
                      }  
                    } else {
                      r = (CompReffer) sectype;
                      kind = r.what;
                    }
                  } else {
                    return null;
                  }
                }  
              } else {
                //!!! vytvor   r  , asi to je takhle
                r = (CompReffer) sectype;               
                ok = true;
              }
            } else {
              return null;
            }  
          } else {  // in normal repository
            try {
              Container con = inRep.cdlRepository;
              id.sn.names.toFirst();
              for(i=0;i<id.sn.names.size();i++) {
                Contained[] a = con.lookup_name((String) id.sn.names.aktual());
                if (a==null || a.length==0) {
                  return null;
                }  
                if (a.length==1) {
                  if (a[0] instanceof Container) con = (Container) a[0];
                  else {
                    return null;
                  }  
                } else {
                  boolean found = false;
                  for(j=0;j<a.length;j++) {
                    if (a[j].get_identification().version().compareTo(id.version)==0) {
                      if ( !(a[j] instanceof Container)) {
                        return null;
                      }  
                      found = true;
                      con = (Container) a[j];
                      break;
                    }
                  }
                  if (!found) {
                    return null;
                  }
                }
                id.sn.names.toNext();
              }
              Contained sec = con.lookup(id.name, id.version);
              if (sec!=null) {
                CDLType sectype = ((TypedefDef) sec).original_type();
                if (sectype.get_def_kind().value() != DefinitionKind.dk_Interface) {
                  if (sectype.get_def_kind().value() == DefinitionKind.dk_Typedef) {
                    CompReffer ret = new CompReffer();
                    ret.what = sectype.get_def_kind().value();
                    ret.ref = new FullID(true);
                    Identification idl;
                    ret.ref.name = new String((idl = ((TypedefDef)sectype).get_identification()).name());
                    ret.ref.version = new String(idl.version());
                    ret.ref.isin = IDKind.version;
                    ret.isNew = false;
                    AbsoluteName abs = idl.absolute_name();
                    for(j=0;j<abs.size();j++) {
                      ret.ref.sn.addScope(new String(abs.elementAt(j)));
                    }
                    r = ret;
                    kind = r.what;
                  } else {
                    if (sectype.get_def_kind().value()==DefinitionKind.dk_Array) {
                      while (sectype.get_def_kind().value()==DefinitionKind.dk_Array) {
                        sectype = ((ArrayDef) sectype).element_type();
                      }
                      if (sectype.get_def_kind().value()!=DefinitionKind.dk_Typedef) {
                        if (sectype.get_def_kind().value()==DefinitionKind.dk_Interface) {
                          CompReffer ret = new CompReffer();
                          ret.what = sectype.get_def_kind().value();
                          ret.ref = new FullID(true);
                          Identification idl;
                          ret.ref.name = new String((idl = ((TypedefDef)sectype).get_identification()).name());
                          ret.ref.version = new String(idl.version());
                          ret.ref.isin = IDKind.version;
                          ret.isNew = false;
                          AbsoluteName abs = idl.absolute_name();
                          for(j=0;j<abs.size();j++) {
                            ret.ref.sn.addScope(new String(abs.elementAt(j)));
                          }
                          r = ret;
                          ok = true;
                        } else { 
                          return null;
                        }
                      } else {
                        CompReffer ret = new CompReffer();
                        ret.what = sectype.get_def_kind().value();
                        ret.ref = new FullID(true);
                        Identification idl;
                        ret.ref.name = new String((idl = ((TypedefDef)sectype).get_identification()).name());
                        ret.ref.version = new String(idl.version());
                        ret.ref.isin = IDKind.version;
                        ret.isNew = false;
                        AbsoluteName abs = idl.absolute_name();
                        for(j=0;j<abs.size();j++) {
                          ret.ref.sn.addScope(new String(abs.elementAt(j)));
                        }
                        r = ret;
                        kind = r.what;   
                      }
                    } else {
                      return null;
                    }
                  }  
                } else {
                  CompReffer ret = new CompReffer();
                  ret.what = sectype.get_def_kind().value();
                  ret.ref = new FullID(true);
                  Identification idl;
                  ret.ref.name = new String((idl = ((TypedefDef)sectype).get_identification()).name());
                  ret.ref.version = new String(idl.version());
                  ret.ref.isin = IDKind.version;
                  ret.isNew = false;
                  AbsoluteName abs = idl.absolute_name();
                  for(j=0;j<abs.size();j++) {
                    ret.ref.sn.addScope(new String(abs.elementAt(j)));
                  }
                  r = ret;
                  ok = true;
                }
              } else {
                return null;
              }
            } catch (TIRExceptLock e) {
              throw new CDLExceptLock("Repository is locked.");
            } catch (RemoteException e) {
              throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
            }
          }
        } else {
          return null;
	}
      } else {
        ok = true;
      }
    }
    return r;
  }

}
