/* $Id: CompSequence.java,v 2.0 2002/02/15 13:54:50 hnetynka Exp $ */
package SOFA.SOFAnode.Made.CDL;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;

class CompSequence extends CompObjectIm implements CompType {
  public CompExprOper bound;
  public CompType type;

  public CompSequence(CompType t, CompExprOper e) {
    super(ObjectsKind.o_Sequence);
    type = t;
    bound = e;
  }

  public CompSequence(CompType t) {
    super(ObjectsKind.o_Sequence);
    type = t;
    bound = new CompExprInteger(0L);
  }

  public void checkConsist(EnumList props, CompRepository rep) throws CDLExceptCheck, CDLExceptLock, CDLExceptRemote {
    if (!CompExprOper.testPropInExpr(props, bound.nameProp(rep)))
      throw new CDLExceptCheck("Unknown property");
    type.checkConsist(props,rep);
  }

  public CDLType toNormal(CDLRepository newRep) throws CDLExceptRemote, CDLExceptToNormal, CDLExceptLock {
    try {
      return newRep.create_sequence(bound.toNormal(newRep), type.toNormal(newRep));
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptCreate e) {
      throw new CDLExceptToNormal("Can't get primitve type\n"+e.getMessage());
    }
  }
}
