/* $Id: EnumMemberImpl.java,v 2.0 2002/02/15 13:55:28 hnetynka Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.io.*;

public class EnumMemberImpl extends UnicastRemoteObject implements EnumMember, TIRImplObject {
  String nm;
  DefinitionKindImpl defKindImpl;
  StateKindImpl stKindImpl;

  EnumMemberImpl normal;

  public EnumMemberImpl(String name) throws RemoteException {
    nm = name;
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_EnumMember);
    stKindImpl = new StateKindImpl(StateKind.sk_work);
    normal = null;
  }

  /* constuctor for load() */
  public EnumMemberImpl() throws RemoteException {
    nm = null;
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_EnumMember);
    stKindImpl = new StateKindImpl(StateKind.sk_normal);
    normal = null;
  } 

  public EnumMemberImpl(EnumMemberImpl a) throws RemoteException {
    nm = a.nm;
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_EnumMember);
    stKindImpl = new StateKindImpl(StateKind.sk_work);
    normal = a;
  }
  
  public String name() throws RemoteException {
    return nm;
  }
  
  /* from interface TIRObject */
  public DefinitionKind get_def_kind() throws RemoteException {
    return (DefinitionKind) defKindImpl;
  }

  /* from interface TIRObject */
  public StateKind get_state() throws RemoteException {
    return (StateKind) stKindImpl;
  }
   
  public void load(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      nm = Storage.readString(st.curInFile);
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't read in file "+st.currentFile+".");
    }
  }

  public void save(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      Storage.writeString(st.curOutFile,nm);  // saving name
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't write in file "+st.currentFile+".");
    }
  }

  public void postLoad(RepositoryImpl r)  throws RemoteException, TIRExceptStorage {
    ;
  }

  public boolean isNew() {
    return ((stKindImpl.value()==StateKind.sk_work) && normal==null);
  }

  public void canCommit() throws RemoteException, TIRExceptCommit {;}

  public void doCommit(Container in, Repository rep) throws RemoteException {
    if (stKindImpl.value()==StateKind.sk_normal)
      return;
    if (isNew()) {  
      stKindImpl.toNormal();
    } else {
      normal = null;
    }
  }

  public void doAbort(long workId) throws RemoteException {}
}
