/* $Id: DeplDockScanner.java,v 1.1 2002/06/28 14:19:39 hnetynka Exp $ */
package SOFA.SOFAnode.Run.Deployment;

import SOFA.SOFAnode.Run.DeplDockRegistry.*;
import SOFA.SOFAnode.Run.Deployment.DeplDock;

import org.omg.CosNaming.*;

/** Prints all components in the depldock.
  *
  * @author Petr Hnetynka
  */
public class DeplDockScanner {
  public static void main(String[] argv) {
    if (argv.length != 1) {
      System.out.println("Bad number of the arguments.");
      System.out.println("Specify name of the deployment dock");
      System.exit(1);
    }

    if (System.getSecurityManager() == null) {
      System.setSecurityManager(new java.rmi.RMISecurityManager());
    }

    SOFA.Util.CORBAAccess ca = new SOFA.Util.CORBAAccess();

    NameComponent nc = new NameComponent("DeplDockRegistry", "");
    NameComponent path[] = {nc};
    DeplDockRegistry ddr = null;
    try {
      System.out.print("Obtaining depldock registry...");
      ddr = DeplDockRegistryHelper.narrow(SOFA.Util.CORBAAccess.ncRef.resolve(path));
      System.out.println("OK");
    } catch (Exception e) {
      System.out.println("Can't get DeplDock registry.");
      e.printStackTrace();
      System.exit(1);
    }
    
    
    byte[] serRef = null;
    try {
      System.out.print("Obtaining reference to depldock...");
      serRef = ddr.lookup(argv[0]);
      System.out.println("OK");
    } catch (NotFoundException e) {
      System.out.println("No deployment dock with name \""+argv[1]+"\".");
      System.exit(1);
    }
    
    SOFA.Connector.Reference ddRef = SOFA.SOFAnode.Run.Deployment.DeplDockImpl.bytesToSofaReference(serRef);
   
    DeplDock ddock = null;
    try {
      System.out.print("Creating connector to depldock...");
      ddock = (DeplDock) SOFA.Connector.Boot.DeplDockConnector.createClt(ddRef);
      System.out.println("OK");
    } catch (SOFA.Connector.ConnectorException e) {
      System.out.println("Can't create connector to deployment dock.");
      System.exit(1);
    }
    
    String[] names = ddock.namesOfAllRunningComponents();
    System.out.print("Number of the components: ");
    System.out.println(names.length);
    for (int i=0; i<names.length; i++) {
      System.out.println(names[i]);
    }
  }
}
